function [nnf, flow] = CombineGlobalAndLocal(opticalFlow, simFlow, trg)

global delta_s;

[h, w, ~] = size(trg);
highSaturatedInds = repmat(sum(trg > delta_s, 3) == 3, [1, 1, 2]);

lOF = opticalFlow.left;
rOF = opticalFlow.right;
lSim = simFlow.left;
rSim = simFlow.right;

lOF(highSaturatedInds) = 0;
rOF(highSaturatedInds) = 0;

flow.left = lOF + lSim;
flow.right = rOF + rSim;

nnf.left = ConvertFlowToNNF(flow.left, h, w);
nnf.right = ConvertFlowToNNF(flow.right, h, w);