function [X, Y, matchX, matchY] = ComputeCorrespondences(trg, src)

%%% This function takes two images and compute the correspondence between
%%% the two using PatchMatch algorithm. The correspondence is found from
%%% target to the source

%%% Declaring global variables ---------
global algo;
global cores;
global patch_w;
global b_max;
%%% ------------------------------------

[h, w, ~] = size(trg);

winSize = b_max * sqrt(h * w);
win = int32(winSize * ones(h, w, 2));

[X, Y] = meshgrid(0 : w-1, 0 : h-1);
nnPrior = int32(cat(3, X, Y, ones(h, w)));

matches = nnmex(trg, src, algo, patch_w, [], [], [], [], [], cores, [], [], [], nnPrior, win);

matchX = double(matches(:, :, 1));
matchY = double(matches(:, :, 2));
