function [warped, simFlow] = ComputeGlobalMotionFlow(imgs, expoTimes)

% global motion for the left image
expAdj = AdjustExposure({imgs.left, imgs.trg}, expoTimes(1:2));
simFlow.left = ComputeSimilarity(expAdj{1}, expAdj{2});

% global motion for the left image
expAdj = AdjustExposure({imgs.right, imgs.trg}, expoTimes(3:-1:2));
simFlow.right = ComputeSimilarity(expAdj{1}, expAdj{2});

% warp the images using the computed global motion
warped.left = WarpUsingFlow(imgs.left, simFlow.left);
warped.trg = imgs.trg;
warped.right = WarpUsingFlow(imgs.right, simFlow.right);