function sMap = ComputeSearchMap(final_NNF, final_field, trg, src)

global patch_w;
global cores;
global algo;
global b_max;
global delta_n;
global b_min;

[h, w, ~] = size(trg);

minWin = ceil(b_min * sqrt(h*w));
maxWin = ceil(b_max * sqrt(h*w));

sMap = ones(h, w, 2);
indUnset = true(h, w);
curWin = minWin;

for i = 1 : 5
    nnfCur = nnmex(trg, src, algo, patch_w, [], [], [], [], [], cores, [], [], [], int32(final_NNF), int32(curWin * ones(h, w, 2)));
    dist = double(nnfCur(:, :, 3)) / (255^2 * patch_w^2);
    
    curInd = indUnset & (dist < delta_n); 
    sMap(repmat(curInd, [1,1,2])) = curWin;
    indUnset = indUnset & ~(dist < delta_n);
    
    curWin = curWin * 2;
end

sMap(repmat(indUnset, [1,1,2])) = maxWin;

warpedSrc = WarpUsingFlow(src, final_field);
sMap = ImproveMap(sMap, trg, warpedSrc, minWin, maxWin);
 
sMap(repmat(~isValidNNF(final_NNF(:, :, 1:2)), [1,1,2])) = maxWin;
