function GenerateMultiScaleData(nnf, sMap, resizeFac, fi)

global numScales;
global patch_w;

lsMap = sMap.left;
rsMap = sMap.right;
lnnf = nnf.left;
rnnf = nnf.right;

dilSize = patch_w * 2;

lnnf = CleanNNF(lnnf);
rnnf = CleanNNF(rnnf);

for si = 2 : numScales
    lnnfCur = imresize(lnnf, 1/resizeFac^(si-1), 'nearest')/resizeFac^(si-1);
    lnnfCur = CleanNNF(lnnfCur);
    lsMapCur = ceil(imresize(lsMap, 1/resizeFac^(si-1), 'nearest')/resizeFac^(si-1)) + 1; % 1 is added for the inaccuracy in downsampling

    
    rnnfCur = imresize(rnnf, 1/resizeFac^(si-1), 'nearest')/resizeFac^(si-1);
    rnnfCur = CleanNNF(rnnfCur);
    rsMapCur = ceil(imresize(rsMap, 1/resizeFac^(si-1), 'nearest')/resizeFac^(si-1)) + 1;  % 1 is added for the inaccuracy in downsampling
    
    if (si ~= numScales)
        SE = strel('square', round(dilSize/resizeFac^(si-1)));
        lsMapCur = imdilate(lsMapCur, SE);
        rsMapCur = imdilate(rsMapCur, SE);    
    end
    
    WriteToBinaryFile(lNNFPriorFile(fi, si), lnnfCur);
    WriteToBinaryFile(lsMapFile(fi, si), lsMapCur);
    WriteToBinaryFile(rNNFPriorFile(fi, si), rnnfCur);
    WriteToBinaryFile(rsMapFile(fi, si), rsMapCur);
    
end


SE = strel('square', round(dilSize));
lsMap = imdilate(lsMap, SE);
rsMap = imdilate(rsMap, SE);

WriteToBinaryFile(lNNFPriorFile(fi, 1), lnnf);
WriteToBinaryFile(lsMapFile(fi, 1), lsMap);
WriteToBinaryFile(rNNFPriorFile(fi, 1), rnnf);
WriteToBinaryFile(rsMapFile(fi, 1), rsMap);
