function [Htilde Hplus Hminus] = HDRmerge(input, alphaPlus, alphaMinus, expoTimes, curRefImgNum)

triFunc = @(x) 2 * (0.5 - abs(0.5 - x));
numInputs = size(input, 2);
[h w c] = size(input{1});
H_LDRs = cell(1, numInputs);
lambda = cell(1, numInputs);

% A large value. Infinity cannot be used.
largeVal = 99999999;

for i = 1 : numInputs
    H_LDRs{i} = LDRtoHDR(input{i}, expoTimes(i));
    lambda{i} = triFunc(input{i});
end

%%% Compute H+ and H- using Eq. 5 ---------------------------
if (curRefImgNum < numInputs)
    Hplus = H_LDRs{numInputs};
    for i = numInputs-1 :-1 : curRefImgNum+1 
        Hplus = (1 - lambda{i}) .* Hplus + lambda{i} .* H_LDRs{i};
    end
    
    HplusContribution = 1;
else
    Hplus = -largeVal * ones(h, w, c);
    HplusContribution = 0;
end

if (curRefImgNum > 1)
    Hminus = H_LDRs{1};
    for i = 2 : curRefImgNum-1
        Hminus = (1 - lambda{i}) .* Hminus + lambda{i} .* H_LDRs{i};
    end
    
    HminusContribution = 1;
else
    Hminus = largeVal * ones(h, w, c);
    HminusContribution = 0;
end
%%% --------------------------------------------------------

%%% Combine H+ and H - to form Htilde ----------------------
Htilde = (alphaPlus.*Hplus*HplusContribution+alphaMinus.*Hminus*HminusContribution)./(alphaPlus*HplusContribution+alphaMinus*HminusContribution);
Htilde((alphaPlus*HplusContribution+alphaMinus*HminusContribution) == 0) = 0;
%%% --------------------------------------------------------