function [nnf, flow] = InitialMotionEstimation(imgs, expoTimes)


mLength = fprintf(' (global)');
[warped, simFlow] = ComputeGlobalMotionFlow(imgs, expoTimes);
fprintf(repmat('\b', 1, mLength));

% The optical flow validation scheme works on triplets of frames. So we
% need to adjust the exposure of all three frames.
warped = AdjustExposure({warped.left, warped.trg, warped.right}, expoTimes);

mLength = fprintf(' (local) ');
opticalFlow = ComputeOpticalFlow(warped);
fprintf(repmat('\b', 1, mLength));

opticalFlow = ValidateBothFlows(opticalFlow);
[nnf, flow] = CombineGlobalAndLocal(opticalFlow, simFlow, warped{2});