function PerformHDRMergeForAllFrames(vidObj, expoTimes, si)

global refInd;

numFrames = vidObj.numFrames;
numExposures = vidObj.numExposures;

for fi = 1 : numFrames
    
    ri = refInd(fi, numExposures);

    alpha = ReadFromBinaryFile(alphaFile(fi, si));
    alphaPlus = ReadFromBinaryFile(alphaPlusFile(fi, si));
    alphaMinus = ReadFromBinaryFile(alphaMinusFile(fi, si));
    VMax = ReadFromBinaryFile(VMaxFile(fi, si));
    VMin = ReadFromBinaryFile(VMinFile(fi, si));

    targets = cell(1, numExposures);
    for ni = 1 : numExposures
        targets{ni} = ReadFromBinaryFile(targetFile(fi, si, ni));
    end

    [Htilde, Hplus, Hminus] = HDRmerge(targets, alphaPlus, alphaMinus, expoTimes, ri);
    Href = LDRtoHDR(targets{ri}, expoTimes(ri));
    H = AlphaBlend(Href, Htilde, alpha);
    H = ConsistencyCheck(Href, H, Hplus, Hminus, VMax, VMin, expoTimes(ri));
    targets = ExtractTargets(targets{ri}, H, expoTimes, ri, false);

    for ni = 1 : numExposures
        WriteToBinaryFile(targetFile(fi, si, ni), targets{ni});
    end

end