function UpSampleTargetsAndNNFs(vidObj, expoTimes, si, h, w)

global refInd;
global DSMethod;
global patch_w;

numFrames = vidObj.numFrames;
numExposures = vidObj.numExposures;

%%% Upsampling all the targets images. The reference image is
%%% directly read from the pyramid.
for fi = 1 : numFrames
    ri = refInd(fi, numExposures);
    for ni = 1 : numExposures
        if (ri ~= ni)
            target = Clamp(imresize(ReadFromBinaryFile(targetFile(fi, si, ni)), [h w], DSMethod), 0, 1);
            WriteToBinaryFile(targetFile(fi, si-1, ni), target);
        end        
    end
end

PerformHDRMergeForAllFrames(vidObj, expoTimes, si-1);

for fi = 1 : numFrames
    for ni = 1 : numExposures
        lNNF = ReadFromBinaryFile(lNNFPrevFile(fi, si, ni));
        if(~isempty(lNNF))
 			lNNF = imresize(lNNF, [h, w], 'nearest');
 			lNNF = CleanNNF(lNNF);
            WriteToBinaryFile(lNNFPrevFile(fi, si-1, ni), lNNF);
        end

        rNNF = ReadFromBinaryFile(rNNFPrevFile(fi, si, ni));
        if(~isempty(rNNF))
 			rNNF = imresize(rNNF, [h, w], 'nearest');
 			rNNF = CleanNNF(rNNF);
            WriteToBinaryFile(rNNFPrevFile(fi, si-1, ni), rNNF);
        end
    end
end
