function warped = WarpUsingFlow(img, flow)

[h, w, c] = size(img);
warped = zeros(h, w, c);

[X, Y] = meshgrid(1:w, 1:h);

for i = 1 : c
    warped(:, :, i) = interp2(X, Y, img(:, :, i), flow(:, :, 1), flow(:, :, 2), 'bicubic');
end

warped(isnan(warped)) = 0;