clear; clc; close all; warning off;

%%% Adding required paths for libraries, mex files, and MATLAB functions
addpath('MexFiles');
addpath(genpath('Functions'));
addpath(genpath('Library'));
%%% ------------------------------------------------


%%% Parameters and input initialization ------------

% The name of the scene to be processed
sceneName = 'ThrowingTowel_2Exp';
%sceneName = 'Fire';


% Input and output folders
outFinalFolder = 'Results';
inputSceneFolder = 'Scenes';

% Initializing all the parameters
profile = 'normal';
InitParams(profile);

% Loading the camera response curve
LoadCRF();
%%% ------------------------------------------------

%---------- Load the images and make the output directories ----------
fprintf('**********************************\n');
fprintf('Working on the "%s" dataset\n', sceneName);
[vidObj, exposureTimes] = ReadSceneFiles(inputSceneFolder, sceneName, outFinalFolder, profile);
%---------------------------------------------------------------------

GenerateHDRVideo(vidObj, exposureTimes, sceneName);

%%% Tonemapping process ---
% Set the tonemapper path here
tonemapperPath = 'C:\Program Files (x86)\Luminance HDR';
if(exist([tonemapperPath, '/luminance-hdr-cli.exe'], 'file'))
    ToneMap(tonemapperPath, inputSceneFolder, sceneName);
end
%%% -----------------------

fprintf('\nFinished working on the "%s" dataset\n', sceneName);

warning on;
